# Flutter 应用实现 google 登录应用


# Flutter 应用实现 google 登录应用


## 开通 google cloud api

- https://console.cloud.google.com/apis/dashboard  启用 google people  和 Identity Toolkit API	
- https://console.cloud.google.com/apis/credentials 添加 web 、 android、iOS 、desktop 你想要的的凭据。

  web 的凭据要添加 Authorised JavaScript origins  ：
  - http://localhost （开发环境）
  - http://localhost:8081 （开发环境）
  - https://youdomain.com (生产环境)


- https://console.cloud.google.com/apis/credentials/consent 配置 OAuth consent screen 同意页面

- 下载 Android 的凭据文件到 ./android/app 目录： google-services.json
- 

## 配置 flutter

flutter pub add google_sign_in

### web

修改 web/index.html，在 head 添加 web 端的 clientid
```html
<meta name="google-signin-client_id"
    content="xxxx.apps.googleusercontent.com">

```

### Android

./android/build.gradle add:
```gradle
buildscript {
    dependencies {
        // Add this line
        classpath 'com.google.gms:google-services:4.3.10'
    }
}
```


./android/app/build.gradle ： 
```gradle

plugins {
  //添加
    id "com.google.gms.google-services"
}

//添加：
dependencies { 
    // Add this dependency
    implementation 'com.google.android.gms:play-services-auth:19.2.0'
}


```

./android/app/src/main/AndroidManifext.xml 
```xml
 <application 
         android:usesCleartextTraffic="true"> 

         <meta-data
            android:name="com.google.android.gms.auth.api.signin.v2.API_KEY"
            android:value="xxxxxb.apps.googleusercontent.com" /> 
    </application>
```


### iOS

TODO: 待补充

### MacOS

TODO: 待补充

### windows

TODO: 待补充
 

### 代码


main.dart
```dart

import 'package:google_sign_in/google_sign_in.dart';
import 'package:http/http.dart' as http;
import 'dart:convert';

```

```dart

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;
  bool _isLeftPanelOpen = true;

  GoogleSignInAccount? _currentUser;
  final GoogleSignIn _googleSignIn = GoogleSignIn( 
    scopes: [
      'email',
      'https://www.googleapis.com/auth/userinfo.profile',
      'https://www.googleapis.com/auth/userinfo.email',
      'https://www.googleapis.com/auth/user.phonenumbers.read',
      'https://www.googleapis.com/auth/user.gender.read',
      'https://www.googleapis.com/auth/user.addresses.read',
    ],
  );

  @override
  void initState() {
.....
    ```


    ```dart

  @override
  void initState() {
    super.initState();
    _googleSignIn.onCurrentUserChanged.listen((GoogleSignInAccount? account) {
      setState(() {
        _currentUser = account;
      });
      if (_currentUser != null) {
        _handleSignIn();
      }
    });
    _googleSignIn.signInSilently();
  }

  Future<void> _handleSignIn() async {
    try {
      GoogleSignInAccount? account = await _googleSignIn.signIn();
      GoogleSignInAuthentication authentication = await account!.authentication;
      String? idToken = authentication.idToken;

      // Send token to the server
      final response = await http.post(
        Uri.parse('https://your-server.com/api/auth/google'),
        headers: {'Content-Type': 'application/json'},
        body: jsonEncode({'token': idToken}),
      );

      if (response.statusCode == 200) {
        // Handle successful response
        final data = jsonDecode(response.body);
        print('Server response: $data');
      } else {
        // Handle error response
        print('Server error: ${response.statusCode}');
      }
    } catch (error) {
      print('Sign-In Error: $error');
    }
  }

  Future<void> _handleSignOut() async {
    await _googleSignIn.disconnect();
  }
  ```


  ```dart

  Widget _buildHeaderUserPanel(GoogleSignInAccount? user) {
    return Container(
      child: user != null
          ? Row(
              children: [
                RuiLoginStatusPanel(
                  userName: user.displayName ?? "",
                  // userPhone: user,
                  userImage: user.photoUrl ?? "",
                  userEmail: user.email,
                ),
                GoogleUserCircleAvatar(identity: user),
                SizedBox(height: 20),
                ElevatedButton(
                  onPressed: _handleSignOut,
                  child: Text('Sign Out'),
                ),
              ],
            )
          : ElevatedButton(
              onPressed: _handleSignIn,
              child: Text('Sign In with Google'),
            ),
    );
  }
  ```
